#!/bin/sh

error() {
	printf "%s\n" "$@" >&2
	exit 1
}

main() {
	# updates triggered through this are always interactive, so allow rollback
	export SW_ALLOW_ROLLBACK=1

	mode="$1"
	shift

	case "$mode" in
	stdin|url) "swupdate_$mode" "$@";;
	*)
		error "Usage: swupdate.sh [stdin|url <url> [<url>...]]"
		;;
	esac
}

swupdate_stdin() {
	exec swupdate -i /proc/self/fd/0
}

swupdate_url() {
	# try all urls given
	for url; do
		echo "Downloading $url..."
		swupdate -d "-u $url"
		# we're done, don't try more
		[ -e /tmp/.swupdate_rebooting ] && exit
	done
}

main "$@"
